#include "avl_functions.h"

	avl_node_t *avl_initialize(avl_node_t *node, uint32_t key) {
		if(!node) return (avl_node_t*)_ret_failure;
		else {
			node->paths[_avl_nodelink_parent] = \
			node->paths[_avl_nodelink_left] = \
			node->paths[_avl_nodelink_right] = (uint32_t)0x00000000;

			node->key = key;
			node->balance = _avl_balance_b;

			return node;
		}
	}

