#include "avl_functions.h"

	void avl_upbalance(avl_node_t **tree, avl_node_t *node, uint8_t stdir) {
		avl_node_t *iterator = node;
		uint32_t path = stdir;

		while(1) {
			iterator->balance += (path ? -1 : 1);
			if((iterator->balance == _avl_balance_lc) || (iterator->balance == _avl_balance_rc)) {
				if(iterator == *tree) {
					*tree = avl_rebalance_tree(iterator, _avl_mode_removal);
					return;
				} else {
					path = (iterator->key > iterator->paths[_avl_nodelink_parent]->key);

					iterator = iterator->paths[_avl_nodelink_parent]->paths[path] = \
						avl_rebalance_tree(iterator->paths[_avl_nodelink_parent]->paths[path], _avl_mode_removal);
				}
			}
			if((iterator->balance == _avl_balance_lh) || (iterator->balance == _avl_balance_rh)) break;
			else if(iterator == *tree) break;
			else {
				path = (iterator->key > iterator->paths[_avl_nodelink_parent]->key);
				iterator = iterator->paths[_avl_nodelink_parent];
			}
		}
	}
