#ifndef _h_zcl_gloomlib_generic
#define _h_zcl_gloomlib_generic

	/* Variable sizing ... */
	typedef unsigned int	uint32_t;
	typedef unsigned short	uint16_t;
	typedef unsigned char	uint8_t;
	typedef signed int	int32_t;
	typedef signed short	int16_t;
	typedef signed char	int8_t;

	/* Generic return values */
	#define _ret_failure	0
	#define _ret_success	1

	/* Debug switches */
	#define __zcl_gloomlib_debug__
	#define __zcl_platform_hosted
	//#define __zcl_platform_zenobit


	/* Conditional inclusion, sets up our Debug-out! */
	#ifdef __zcl_gloomlib_debug__
		#ifdef __zcl_platform_hosted
			#include <stdio.h>
			#include <stdlib.h>
			#define _macro_dbgout	printf
		#endif
		#ifdef __zcl_platform_zenobit
			#include <uart_functions.h>
			#define _macro_dbgout	sprintf
		#endif
	#endif

#endif
