#include "sll_functions.h"

	sll_node_t *sll_remove(sll_header_t *list, sll_node_t *node) {
		if((!list) || (!node)) return (sll_node_t*)_ret_failure;
		else {
			sll_node_t *point = list->links[_sll_headerlink_head];

			if(list->links[_sll_headerlink_head] == node) {
				if(node->nextlink)
					list->links[_sll_headerlink_head] = node->nextlink;
				else
					list->links[_sll_headerlink_head] = \
					list->links[_sll_headerlink_tail] = 0x00000000;
			} else {
				while(point->nextlink != node) point = point->nextlink;

				if(list->links[_sll_headerlink_tail] == node) {
					point->nextlink = 0x00000000;
					list->links[_sll_headerlink_tail] = point;
				} else {
					point->nextlink = node->nextlink;
				}
			}
			return node;
		}
	}
