#ifndef _h_zcl_gloomlib_sll_structures
#define _h_zcl_gloomlib_sll_structures

	/* Here is defined the SLL Node structure.
	   It can be expanded should you need. */
	typedef struct sll_node_def sll_node_t;

	struct sll_node_def {
		sll_node_t *nextlink;
	};

	/* Then, we define the SLL Header structure. This header
	   structure lets us know at all times, the exact end of the
	   list. This is useful, because it speeds up Insertion times
	   since we dont have to spend valuable clocks scanning. */
	#define _sll_headerlink_head	0
	#define _sll_headerlink_tail	1

	typedef struct sll_header_def sll_header_t;

	struct sll_header_def {
		sll_node_t *links[2];		
	};

#endif
