#include "avl_functions.h"

	avl_node_t *avl_locate(avl_node_t **tree, unsigned int key) {
		if((!tree) || (!*tree)) return (avl_node_t*)_ret_failure;
		else {
			avl_node_t *point = *tree;
			uint32_t path = 0;

			while(point) {
				path = (key > point->key);

				if(point->key == key) break;
				else point = point->paths[path];
			}
			return point;
		}
	}
