#include "avl_functions.h"

	avl_node_t *avl_rotate_tree(avl_node_t *subtree, uint8_t direction) {
		avl_node_t *new_root = subtree->paths[!direction];
		subtree->paths[!direction] = new_root->paths[direction];

		if(subtree->paths[!direction])
			subtree->paths[!direction]->paths[_avl_nodelink_parent]\
				= subtree;

		new_root->paths[direction] = subtree;

		new_root->paths[_avl_nodelink_parent] = \
			subtree->paths[_avl_nodelink_parent];

		subtree->paths[_avl_nodelink_parent] = new_root;

		return new_root;
	}
