#include "avl_functions.h"

	#ifdef __zcl_gloomlib_debug__
		void avl_showtree(avl_node_t **tree, avl_node_t *node) {
			if(node) {
				avl_showtree(tree, node->paths[_avl_nodelink_left]);

				if(node == *tree)
					_macro_dbgout("[ root ] : ");
				else if((node->paths[_avl_nodelink_left]) && (node->paths[_avl_nodelink_right]))
					_macro_dbgout("[ subt ] : ");
				else if(node->paths[_avl_nodelink_left])
					_macro_dbgout("[ lbch ] : ");
				else if(node->paths[_avl_nodelink_right])
					_macro_dbgout("[ rbch ] : ");
				else _macro_dbgout("[ leaf ] : ");

				_macro_dbgout("k: %d, b %d\r\n", node->key, node->balance);

				if(node->paths[_avl_nodelink_left]) _macro_dbgout(" - l %d\r\n", node->paths[_avl_nodelink_left]->key); 
				if(node->paths[_avl_nodelink_parent]) _macro_dbgout(" - u %d\r\n", node->paths[_avl_nodelink_parent]->key); 
				if(node->paths[_avl_nodelink_right]) _macro_dbgout(" - r %d\r\n", node->paths[_avl_nodelink_right]->key); 

				avl_showtree(tree, node->paths[_avl_nodelink_right]);
			} else return;
		}
	#endif
