#include "bst_functions.h"

	bst_node_t *bst_insert(bst_node_t **tree, bst_node_t *node) {
		if((!tree) || (!node)) return (bst_node_t*)_ret_failure;
		else if(!*tree) *tree = node;
		else {
			bst_node_t *point = *tree;
			uint32_t path = 0;

			while(1) {
				path = (node->key > point->key);
				
				if(point->key == node->key) return node;
				else if(point->links[path]) point = point->links[path];
				else {
					point->links[path] = node;
					break;
				}
			}
		}
		return node;
	}
