#include "bst_functions.h"

	bst_node_t *bst_remove(bst_node_t **tree, bst_node_t *node) {
		if((!tree) || (!*tree) || (!node)) return (bst_node_t*)_ret_failure;
		else {
			uint32_t path = 0;

			if(node != *tree) path = (node->key > link_node->key);

			if((node->links[_bst_nodelink_left]) && \
			   (node->links[_bst_nodelink_right])) {
				bst_node_t *replacement = node->links[_bst_nodelink_left];

				link_node = node;

				while(replacement->links[_bst_nodelink_right]) {
					link_node = replacement;
					replacement = replacement->links[_bst_nodelink_right];
				}

				path = (replacement->key > link_node->key);

				if(replacement->links[_bst_nodelink_left]) {
					node->key = replacement->key;
					replacement->key = \
					replacement->links[_bst_nodelink_left]->key;

					link_node = replacement->links[_bst_nodelink_left];
					replacement->links[_bst_nodelink_left] = 0x00000000;

					replacement = link_node;
				} else {
					node->key = replacement->key;
					link_node->links[path] = 0x00000000;					
				}
	
				return replacement;
			} else if((!node->links[_bst_nodelink_left]) && \
			          (!node->links[_bst_nodelink_right])) {
				if(*tree == node) *tree = 0x00000000;
				else link_node->links[path] = 0x00000000;
			} else {
				if(node->links[_bst_nodelink_left]) {
					if(*tree == node) *tree = node->links[_bst_nodelink_left];
					else link_node->links[path] = node->links[_bst_nodelink_left];
				} else {
					if(*tree == node) *tree = node->links[_bst_nodelink_right];
					else link_node->links[path] = node->links[_bst_nodelink_right];
				}
			}

			return node;
		}
	}
