#include "dll_functions.h"

	#ifdef __zcl_gloomlib_debug__
		void dll_showlist(dll_header_t *header) {
			_macro_dbgout(" - dll_showlist(h:0x%X):\r\n", (uint32_t)header);
			if(!header) {
				_macro_dbgout("failure.\r\n");
				_macro_dbgout("   - Header passed is invalid.\r\n");
			} else {
				_macro_dbgout("   - List head: 0x%X\r\n",\
					      (uint32_t)header->links[_dll_headerlink_head]);
				_macro_dbgout("   - List tail: 0x%X\r\n",\
					      (uint32_t)header->links[_dll_headerlink_tail]);
				_macro_dbgout("   - List traversal:\r\n");

				dll_node_t *traversal = header->links[_dll_headerlink_head];

				while(traversal) {
					_macro_dbgout("     - node(0x%X), plink:0x%x nlink:0x%X\r\n",\
						      (uint32_t)traversal,\
						      (uint32_t)traversal->links[_dll_nodelink_previous],\
						      (uint32_t)traversal->links[_dll_nodelink_next]);

					traversal = traversal->links[_dll_nodelink_next];
				}
			}
		}
	#endif
