#include "sll_functions.h"

	#ifdef __zcl_gloomlib_debug__
		void sll_showlist(sll_header_t *list) {
			_macro_dbgout(" - sll_showlist(h:0x%X):\r\n", (uint32_t)list);
			if(!list) {
				_macro_dbgout("failure.\r\n");
				_macro_dbgout("   - Header passed is invalid.\r\n");
			} else {
				_macro_dbgout("   - List head: 0x%X\r\n",\
					      (uint32_t)list->links[_sll_headerlink_head]);
				_macro_dbgout("   - List tail: 0x%X\r\n",\
					      (uint32_t)list->links[_sll_headerlink_tail]);
				_macro_dbgout("   - List traversal:\r\n");

				sll_node_t *traversal = list->links[_sll_headerlink_head];

				while(traversal) {
					_macro_dbgout("     - node(0x%X), nlink:0x%X\r\n",\
						      (uint32_t)traversal,\
						      (uint32_t)traversal->nextlink);

					traversal = traversal->nextlink;
				}
			}
		}
	#endif
